import{S as sm,i as im,s as mm,e as a,k as d,w as h,t as s,M as dm,c as n,d as t,m as c,a as r,x as g,h as i,b as m,N as cm,G as e,g as p,y as u,q as _,o as v,B as b,v as lm,L as pm}from"../../chunks/vendor-hf-doc-builder.js";import{T as fm}from"../../chunks/Tip-hf-doc-builder.js";import{D as C}from"../../chunks/Docstring-hf-doc-builder.js";import{C as rm}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as ne}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as hm}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function gm(So){let y,I,w,$,x;return $=new rm({props:{code:`from transformers import (
    SamVisionConfig,
    SamPromptEncoderConfig,
    SamMaskDecoderConfig,
    SamModel,
)

# Initializing a SamConfig with \`"facebook/sam-vit-huge"\` style configuration
configuration = SamConfig()

# Initializing a SamModel (with random weights) from the \`"facebook/sam-vit-huge"\` style configuration
model = SamModel(configuration)

# Accessing the model configuration
configuration = model.config

# We can also initialize a SamConfig from a SamVisionConfig, SamPromptEncoderConfig, and SamMaskDecoderConfig

# Initializing SAM vision, SAM Q-Former and language model configurations
vision_config = SamVisionConfig()
prompt_encoder_config = SamPromptEncoderConfig()
mask_decoder_config = SamMaskDecoderConfig()

config = SamConfig(vision_config, prompt_encoder_config, mask_decoder_config)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> (
<span class="hljs-meta">... </span>    SamVisionConfig,
<span class="hljs-meta">... </span>    SamPromptEncoderConfig,
<span class="hljs-meta">... </span>    SamMaskDecoderConfig,
<span class="hljs-meta">... </span>    SamModel,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a SamConfig with \`&quot;facebook/sam-vit-huge&quot;\` style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = SamConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a SamModel (with random weights) from the \`&quot;facebook/sam-vit-huge&quot;\` style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = SamModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># We can also initialize a SamConfig from a SamVisionConfig, SamPromptEncoderConfig, and SamMaskDecoderConfig</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing SAM vision, SAM Q-Former and language model configurations</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>vision_config = SamVisionConfig()
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_encoder_config = SamPromptEncoderConfig()
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_decoder_config = SamMaskDecoderConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span>config = SamConfig(vision_config, prompt_encoder_config, mask_decoder_config)`}}),{c(){y=a("p"),I=s("Example:"),w=d(),h($.$$.fragment)},l(f){y=n(f,"P",{});var z=r(y);I=i(z,"Example:"),z.forEach(t),w=c(f),g($.$$.fragment,f)},m(f,z){p(f,y,z),e(y,I),p(f,w,z),u($,f,z),x=!0},p:pm,i(f){x||(_($.$$.fragment,f),x=!0)},o(f){v($.$$.fragment,f),x=!1},d(f){f&&t(y),f&&t(w),b($,f)}}}function um(So){let y,I,w,$,x;return{c(){y=a("p"),I=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),w=a("code"),$=s("Module"),x=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(f){y=n(f,"P",{});var z=r(y);I=i(z,"Although the recipe for forward pass needs to be defined within this function, one should call the "),w=n(z,"CODE",{});var re=r(w);$=i(re,"Module"),re.forEach(t),x=i(z,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),z.forEach(t)},m(f,z){p(f,y,z),e(y,I),e(y,w),e(w,$),e(y,x)},d(f){f&&t(y)}}}function _m(So){let y,I,w,$,x,f,z,re,La,Vt,W,se,rt,Ce,qa,st,Ra,Ut,ie,Va,xe,Ua,Oa,Ot,wo,Wa,Wt,$o,zo,Ds,Ft,ko,Fa,Bt,Po,Ee,Ba,Te,Ha,Ga,Ht,Co,Ya,Gt,E,it,Xa,Za,mt,Ja,Ka,dt,Qa,en,ct,on,tn,Ie,an,Me,nn,rn,Yt,M,sn,De,mn,dn,Ae,cn,ln,Ne,pn,fn,Xt,xo,hn,Zt,je,Jt,Eo,gn,Kt,To,Io,Le,un,_n,Qt,F,me,lt,qe,vn,pt,bn,ea,P,Re,yn,q,Mo,Sn,wn,Do,$n,zn,Ve,kn,Pn,Cn,B,xn,Ao,En,Tn,No,In,Mn,Dn,de,An,ce,Ue,Nn,Oe,jn,jo,Ln,qn,oa,H,le,ft,We,Rn,ht,Vn,ta,D,Fe,Un,G,On,gt,Wn,Fn,Be,Bn,Hn,Gn,Y,Yn,Lo,Xn,Zn,qo,Jn,Kn,aa,X,pe,ut,He,Qn,_t,er,na,A,Ge,or,Z,tr,vt,ar,nr,Ye,rr,sr,ir,J,mr,Ro,dr,cr,Vo,lr,pr,ra,K,fe,bt,Xe,fr,yt,hr,sa,N,Ze,gr,j,ur,St,_r,vr,wt,br,yr,Je,Sr,wr,$r,Q,zr,Uo,kr,Pr,Oo,Cr,xr,ia,ee,he,$t,Ke,Er,zt,Tr,ma,L,Qe,Ir,kt,Mr,Dr,R,Wo,Ar,Nr,Fo,jr,Lr,eo,Pt,qr,Rr,Vr,da,oe,ge,Ct,oo,Ur,xt,Or,ca,S,to,Wr,Et,Fr,Br,ue,ao,Hr,Tt,Gr,Yr,_e,no,Xr,ro,Zr,It,Jr,Kr,Qr,ve,so,es,Mt,os,ts,be,io,as,Dt,ns,rs,ye,mo,ss,At,is,ms,Se,co,ds,lo,cs,Nt,ls,ps,la,te,we,jt,po,fs,Lt,hs,pa,T,fo,gs,ho,us,Bo,_s,vs,bs,go,ys,uo,Ss,ws,$s,V,_o,zs,ae,ks,Ho,Ps,Cs,qt,xs,Es,Ts,$e,fa;return f=new ne({}),Ce=new ne({}),je=new rm({props:{code:`import torch
from PIL import Image
import requests
from transformers import SamModel, SamProcessor

device = "cuda" if torch.cuda.is_available() else "cpu"
model = SamModel.from_pretrained("facebook/sam-vit-huge").to(device)
processor = SamProcessor.from_pretrained("facebook/sam-vit-huge")

img_url = "https://huggingface.co/ybelkada/segment-anything/resolve/main/assets/car.png"
raw_image = Image.open(requests.get(img_url, stream=True).raw).convert("RGB")
input_points = [[[450, 600]]]  # 2D location of a window in the image

inputs = processor(raw_image, input_points=input_points, return_tensors="pt").to(device)
outputs = model(**inputs)

masks = processor.image_processor.post_process_masks(
    outputs.pred_masks.cpu(), inputs["original_sizes"].cpu(), inputs["reshaped_input_sizes"].cpu()
)
scores = outputs.iou_scores`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> requests
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> SamModel, SamProcessor

device = <span class="hljs-string">&quot;cuda&quot;</span> <span class="hljs-keyword">if</span> torch.cuda.is_available() <span class="hljs-keyword">else</span> <span class="hljs-string">&quot;cpu&quot;</span>
model = SamModel.from_pretrained(<span class="hljs-string">&quot;facebook/sam-vit-huge&quot;</span>).to(device)
processor = SamProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/sam-vit-huge&quot;</span>)

img_url = <span class="hljs-string">&quot;https://huggingface.co/ybelkada/segment-anything/resolve/main/assets/car.png&quot;</span>
raw_image = Image.<span class="hljs-built_in">open</span>(requests.get(img_url, stream=<span class="hljs-literal">True</span>).raw).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
input_points = [[[<span class="hljs-number">450</span>, <span class="hljs-number">600</span>]]]  <span class="hljs-comment"># 2D location of a window in the image</span>

inputs = processor(raw_image, input_points=input_points, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).to(device)
outputs = model(**inputs)

masks = processor.image_processor.post_process_masks(
    outputs.pred_masks.cpu(), inputs[<span class="hljs-string">&quot;original_sizes&quot;</span>].cpu(), inputs[<span class="hljs-string">&quot;reshaped_input_sizes&quot;</span>].cpu()
)
scores = outputs.iou_scores`}}),qe=new ne({}),Re=new C({props:{name:"class transformers.SamConfig",anchor:"transformers.SamConfig",parameters:[{name:"vision_config",val:" = None"},{name:"prompt_encoder_config",val:" = None"},{name:"mask_decoder_config",val:" = None"},{name:"initializer_range",val:" = 0.02"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamConfig.vision_config",description:`<strong>vision_config</strong> (Union[<code>dict</code>, <code>SamVisionConfig</code>], <em>optional</em>) &#x2014;
Dictionary of configuration options used to initialize <a href="/docs/transformers/main/en/model_doc/sam#transformers.SamVisionConfig">SamVisionConfig</a>.`,name:"vision_config"},{anchor:"transformers.SamConfig.prompt_encoder_config",description:`<strong>prompt_encoder_config</strong> (Union[<code>dict</code>, <code>SamPromptEncoderConfig</code>], <em>optional</em>) &#x2014;
Dictionary of configuration options used to initialize <a href="/docs/transformers/main/en/model_doc/sam#transformers.SamPromptEncoderConfig">SamPromptEncoderConfig</a>.`,name:"prompt_encoder_config"},{anchor:"transformers.SamConfig.mask_decoder_config",description:`<strong>mask_decoder_config</strong> (Union[<code>dict</code>, <code>SamMaskDecoderConfig</code>], <em>optional</em>) &#x2014;
Dictionary of configuration options used to initialize <a href="/docs/transformers/main/en/model_doc/sam#transformers.SamMaskDecoderConfig">SamMaskDecoderConfig</a>.`,name:"mask_decoder_config"},{anchor:"transformers.SamConfig.kwargs",description:`<strong>kwargs</strong> (<em>optional</em>) &#x2014;
Dictionary of keyword arguments.`,name:"kwargs"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/sam/configuration_sam.py#L254"}}),de=new hm({props:{anchor:"transformers.SamConfig.example",$$slots:{default:[gm]},$$scope:{ctx:So}}}),Ue=new C({props:{name:"to_dict",anchor:"transformers.SamConfig.to_dict",parameters:[],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/sam/configuration_sam.py#L332",returnDescription:`
<p>Dictionary of all the attributes that make up this configuration instance,</p>
`,returnType:`
<p><code>Dict[str, any]</code></p>
`}}),We=new ne({}),Fe=new C({props:{name:"class transformers.SamVisionConfig",anchor:"transformers.SamVisionConfig",parameters:[{name:"hidden_size",val:" = 768"},{name:"intermediate_size",val:" = 6144"},{name:"projection_dim",val:" = 512"},{name:"output_channels",val:" = 256"},{name:"num_hidden_layers",val:" = 12"},{name:"num_attention_heads",val:" = 12"},{name:"num_channels",val:" = 3"},{name:"image_size",val:" = 1024"},{name:"patch_size",val:" = 16"},{name:"hidden_act",val:" = 'gelu'"},{name:"layer_norm_eps",val:" = 1e-06"},{name:"dropout",val:" = 0.0"},{name:"attention_dropout",val:" = 0.0"},{name:"initializer_range",val:" = 1e-10"},{name:"initializer_factor",val:" = 1.0"},{name:"qkv_bias",val:" = True"},{name:"mlp_ratio",val:" = 4.0"},{name:"use_abs_pos",val:" = True"},{name:"use_rel_pos",val:" = True"},{name:"window_size",val:" = 14"},{name:"global_attn_indexes",val:" = [2, 5, 8, 11]"},{name:"num_pos_feats",val:" = 128"},{name:"mlp_dim",val:" = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamVisionConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
Dimensionality of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.SamVisionConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 6144) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"intermediate_size"},{anchor:"transformers.SamVisionConfig.projection_dim",description:`<strong>projection_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 512) &#x2014;
Dimensionality of the projection layer in the Transformer encoder.`,name:"projection_dim"},{anchor:"transformers.SamVisionConfig.output_channels",description:`<strong>output_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Dimensionality of the output channels in the Patch Encoder.`,name:"output_channels"},{anchor:"transformers.SamVisionConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.SamVisionConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.SamVisionConfig.num_channels",description:`<strong>num_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
Number of channels in the input image.`,name:"num_channels"},{anchor:"transformers.SamVisionConfig.image_size",description:`<strong>image_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1024) &#x2014;
Expected resolution. Target size of the resized input image.`,name:"image_size"},{anchor:"transformers.SamVisionConfig.patch_size",description:`<strong>patch_size</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
Size of the patches to be extracted from the input image.`,name:"patch_size"},{anchor:"transformers.SamVisionConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string)`,name:"hidden_act"},{anchor:"transformers.SamVisionConfig.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-6) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"},{anchor:"transformers.SamVisionConfig.dropout",description:`<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout probability.`,name:"dropout"},{anchor:"transformers.SamVisionConfig.attention_dropout",description:`<strong>attention_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_dropout"},{anchor:"transformers.SamVisionConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-10) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.SamVisionConfig.initializer_factor",description:`<strong>initializer_factor</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014;
A factor for multiplying the initializer range.`,name:"initializer_factor"},{anchor:"transformers.SamVisionConfig.qkv_bias",description:`<strong>qkv_bias</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to add a bias to query, key, value projections.`,name:"qkv_bias"},{anchor:"transformers.SamVisionConfig.mlp_ratio",description:`<strong>mlp_ratio</strong> (<code>float</code>, <em>optional</em>, defaults to 4.0) &#x2014;
Ratio of mlp hidden dim to embedding dim.`,name:"mlp_ratio"},{anchor:"transformers.SamVisionConfig.use_abs_pos",description:`<strong>use_abs_pos</strong> (<code>bool</code>, <em>optional</em>, defaults to True) &#x2014;
Whether to use absolute position embedding.`,name:"use_abs_pos"},{anchor:"transformers.SamVisionConfig.use_rel_pos",description:`<strong>use_rel_pos</strong> (<code>bool</code>, <em>optional</em>, defaults to True) &#x2014;
Whether to use relative position embedding.`,name:"use_rel_pos"},{anchor:"transformers.SamVisionConfig.window_size",description:`<strong>window_size</strong> (<code>int</code>, <em>optional</em>, defaults to 14) &#x2014;
Window size for relative position.`,name:"window_size"},{anchor:"transformers.SamVisionConfig.global_attn_indexes",description:`<strong>global_attn_indexes</strong> (<code>List[int]</code>, <em>optional</em>, defaults to <code>[2, 5, 8, 11]</code>) &#x2014;
The indexes of the global attention layers.`,name:"global_attn_indexes"},{anchor:"transformers.SamVisionConfig.num_pos_feats",description:`<strong>num_pos_feats</strong> (<code>int</code>, <em>optional</em>, defaults to 128) &#x2014;
The dimensionality of the position embedding.`,name:"num_pos_feats"},{anchor:"transformers.SamVisionConfig.mlp_dim",description:`<strong>mlp_dim</strong> (<code>int</code>, <em>optional</em>, defaults to None) &#x2014;
The dimensionality of the MLP layer in the Transformer encoder. If <code>None</code>, defaults to <code>mlp_ratio * hidden_size</code>.`,name:"mlp_dim"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/sam/configuration_sam.py#L140"}}),He=new ne({}),Ge=new C({props:{name:"class transformers.SamMaskDecoderConfig",anchor:"transformers.SamMaskDecoderConfig",parameters:[{name:"hidden_size",val:" = 256"},{name:"hidden_act",val:" = 'relu'"},{name:"mlp_dim",val:" = 2048"},{name:"num_hidden_layers",val:" = 2"},{name:"num_attention_heads",val:" = 8"},{name:"attention_downsample_rate",val:" = 2"},{name:"num_multimask_outputs",val:" = 3"},{name:"iou_head_depth",val:" = 3"},{name:"iou_head_hidden_dim",val:" = 256"},{name:"layer_norm_eps",val:" = 1e-06"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamMaskDecoderConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Dimensionality of the hidden states.`,name:"hidden_size"},{anchor:"transformers.SamMaskDecoderConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;relu&quot;</code>) &#x2014;
The non-linear activation function used inside the <code>SamMaskDecoder</code> module.`,name:"hidden_act"},{anchor:"transformers.SamMaskDecoderConfig.mlp_dim",description:`<strong>mlp_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"mlp_dim"},{anchor:"transformers.SamMaskDecoderConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.SamMaskDecoderConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.SamMaskDecoderConfig.attention_downsample_rate",description:`<strong>attention_downsample_rate</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014;
The downsampling rate of the attention layer.`,name:"attention_downsample_rate"},{anchor:"transformers.SamMaskDecoderConfig.num_multimask_outputs",description:`<strong>num_multimask_outputs</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
The number of outputs from the <code>SamMaskDecoder</code> module. In the Segment Anything paper, this is set to 3.`,name:"num_multimask_outputs"},{anchor:"transformers.SamMaskDecoderConfig.iou_head_depth",description:`<strong>iou_head_depth</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
The number of layers in the IoU head module.`,name:"iou_head_depth"},{anchor:"transformers.SamMaskDecoderConfig.iou_head_hidden_dim",description:`<strong>iou_head_hidden_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
The dimensionality of the hidden states in the IoU head module.`,name:"iou_head_hidden_dim"},{anchor:"transformers.SamMaskDecoderConfig.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-6) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/sam/configuration_sam.py#L79"}}),Xe=new ne({}),Ze=new C({props:{name:"class transformers.SamPromptEncoderConfig",anchor:"transformers.SamPromptEncoderConfig",parameters:[{name:"hidden_size",val:" = 256"},{name:"image_size",val:" = 1024"},{name:"patch_size",val:" = 16"},{name:"mask_input_channels",val:" = 16"},{name:"num_point_embeddings",val:" = 4"},{name:"hidden_act",val:" = 'gelu'"},{name:"layer_norm_eps",val:" = 1e-06"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamPromptEncoderConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Dimensionality of the hidden states.`,name:"hidden_size"},{anchor:"transformers.SamPromptEncoderConfig.image_size",description:`<strong>image_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1024) &#x2014;
The expected output resolution of the image.`,name:"image_size"},{anchor:"transformers.SamPromptEncoderConfig.patch_size",description:`<strong>patch_size</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
The size (resolution) of each patch.`,name:"patch_size"},{anchor:"transformers.SamPromptEncoderConfig.mask_input_channels",description:`<strong>mask_input_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
The number of channels to be fed to the <code>MaskDecoder</code> module.`,name:"mask_input_channels"},{anchor:"transformers.SamPromptEncoderConfig.num_point_embeddings",description:`<strong>num_point_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
The number of point embeddings to be used.`,name:"num_point_embeddings"},{anchor:"transformers.SamPromptEncoderConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function in the encoder and pooler.`,name:"hidden_act"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/sam/configuration_sam.py#L32"}}),Ke=new ne({}),Qe=new C({props:{name:"class transformers.SamProcessor",anchor:"transformers.SamProcessor",parameters:[{name:"image_processor",val:""}],parametersDescription:[{anchor:"transformers.SamProcessor.image_processor",description:`<strong>image_processor</strong> (<code>SamImageProcessor</code>) &#x2014;
An instance of <a href="/docs/transformers/main/en/model_doc/sam#transformers.SamImageProcessor">SamImageProcessor</a>. The image processor is a required input.`,name:"image_processor"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/sam/processing_sam.py#L32"}}),oo=new ne({}),to=new C({props:{name:"class transformers.SamImageProcessor",anchor:"transformers.SamImageProcessor",parameters:[{name:"do_resize",val:": bool = True"},{name:"size",val:": typing.Dict[str, int] = None"},{name:"resample",val:": Resampling = <Resampling.BILINEAR: 2>"},{name:"do_rescale",val:": bool = True"},{name:"rescale_factor",val:": typing.Union[int, float] = 0.00392156862745098"},{name:"do_normalize",val:": bool = True"},{name:"image_mean",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"do_pad",val:": bool = True"},{name:"pad_size",val:": int = None"},{name:"do_convert_rgb",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamImageProcessor.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to resize the image&#x2019;s (height, width) dimensions to the specified <code>size</code>. Can be overridden by the
<code>do_resize</code> parameter in the <code>preprocess</code> method.`,name:"do_resize"},{anchor:"transformers.SamImageProcessor.size",description:`<strong>size</strong> (<code>dict</code>, <em>optional</em>, defaults to <code>{&quot;longest_edge&quot; -- 1024}</code>):
Size of the output image after resizing. Resizes the longest edge of the image to match
<code>size[&quot;longest_edge&quot;]</code> while maintaining the aspect ratio. Can be overridden by the <code>size</code> parameter in the
<code>preprocess</code> method.`,name:"size"},{anchor:"transformers.SamImageProcessor.resample",description:`<strong>resample</strong> (<code>PILImageResampling</code>, <em>optional</em>, defaults to <code>PILImageResampling.BICUBIC</code>) &#x2014;
Resampling filter to use if resizing the image. Can be overridden by the <code>resample</code> parameter in the
<code>preprocess</code> method.`,name:"resample"},{anchor:"transformers.SamImageProcessor.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Wwhether to rescale the image by the specified scale <code>rescale_factor</code>. Can be overridden by the
<code>do_rescale</code> parameter in the <code>preprocess</code> method.`,name:"do_rescale"},{anchor:"transformers.SamImageProcessor.rescale_factor",description:`<strong>rescale_factor</strong> (<code>int</code> or <code>float</code>, <em>optional</em>, defaults to <code>1/255</code>) &#x2014;
Scale factor to use if rescaling the image. Only has an effect if <code>do_rescale</code> is set to <code>True</code>. Can be
overridden by the <code>rescale_factor</code> parameter in the <code>preprocess</code> method.`,name:"rescale_factor"},{anchor:"transformers.SamImageProcessor.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to normalize the image. Can be overridden by the <code>do_normalize</code> parameter in the <code>preprocess</code>
method. Can be overridden by the <code>do_normalize</code> parameter in the <code>preprocess</code> method.`,name:"do_normalize"},{anchor:"transformers.SamImageProcessor.image_mean",description:`<strong>image_mean</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>IMAGENET_DEFAULT_MEAN</code>) &#x2014;
Mean to use if normalizing the image. This is a float or list of floats the length of the number of
channels in the image. Can be overridden by the <code>image_mean</code> parameter in the <code>preprocess</code> method. Can be
overridden by the <code>image_mean</code> parameter in the <code>preprocess</code> method.`,name:"image_mean"},{anchor:"transformers.SamImageProcessor.image_std",description:`<strong>image_std</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>IMAGENET_DEFAULT_STD</code>) &#x2014;
Standard deviation to use if normalizing the image. This is a float or list of floats the length of the
number of channels in the image. Can be overridden by the <code>image_std</code> parameter in the <code>preprocess</code> method.
Can be overridden by the <code>image_std</code> parameter in the <code>preprocess</code> method.`,name:"image_std"},{anchor:"transformers.SamImageProcessor.do_pad",description:`<strong>do_pad</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to pad the image to the specified <code>pad_size</code>. Can be overridden by the <code>do_pad</code> parameter in the
<code>preprocess</code> method.`,name:"do_pad"},{anchor:"transformers.SamImageProcessor.pad_size",description:`<strong>pad_size</strong> (<code>dict</code>, <em>optional</em>, defaults to <code>{&quot;height&quot; -- 1024, &quot;width&quot;: 1024}</code>):
Size of the output image after padding. Can be overridden by the <code>pad_size</code> parameter in the <code>preprocess</code>
method.`,name:"pad_size"},{anchor:"transformers.SamImageProcessor.do_convert_rgb",description:`<strong>do_convert_rgb</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to convert the image to RGB.`,name:"do_convert_rgb"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/sam/image_processing_sam.py#L43"}}),ao=new C({props:{name:"normalize",anchor:"transformers.SamImageProcessor.normalize",parameters:[{name:"image",val:": ndarray"},{name:"mean",val:": typing.Union[float, typing.List[float]]"},{name:"std",val:": typing.Union[float, typing.List[float]]"},{name:"data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension, NoneType] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamImageProcessor.normalize.image",description:`<strong>image</strong> (<code>np.ndarray</code>) &#x2014;
Image to normalize.`,name:"image"},{anchor:"transformers.SamImageProcessor.normalize.mean",description:`<strong>mean</strong> (<code>float</code> or <code>List[float]</code>) &#x2014;
Image mean.`,name:"mean"},{anchor:"transformers.SamImageProcessor.normalize.std",description:`<strong>std</strong> (<code>float</code> or <code>List[float]</code>) &#x2014;
Image standard deviation.`,name:"std"},{anchor:"transformers.SamImageProcessor.normalize.data_format",description:`<strong>data_format</strong> (<code>str</code> or <code>ChannelDimension</code>, <em>optional</em>) &#x2014;
The channel dimension format of the image. If not provided, it will be the same as the input image.`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/sam/image_processing_sam.py#L215"}}),no=new C({props:{name:"pad_image",anchor:"transformers.SamImageProcessor.pad_image",parameters:[{name:"image",val:": ndarray"},{name:"pad_size",val:": typing.Dict[str, int]"},{name:"data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension, NoneType] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamImageProcessor.pad_image.image",description:`<strong>image</strong> (<code>np.ndarray</code>) &#x2014;
Image to pad.`,name:"image"},{anchor:"transformers.SamImageProcessor.pad_image.pad_size",description:`<strong>pad_size</strong> (<code>Dict[str, int]</code>) &#x2014;
Size of the output image after padding.`,name:"pad_size"},{anchor:"transformers.SamImageProcessor.pad_image.data_format",description:`<strong>data_format</strong> (<code>str</code> or <code>ChannelDimension</code>, <em>optional</em>) &#x2014;
The data format of the image. Can be either &#x201C;channels_first&#x201D; or &#x201C;channels_last&#x201D;. If <code>None</code>, the
<code>data_format</code> of the <code>image</code> will be used.`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/sam/image_processing_sam.py#L121"}}),so=new C({props:{name:"post_process_masks",anchor:"transformers.SamImageProcessor.post_process_masks",parameters:[{name:"masks",val:""},{name:"original_sizes",val:""},{name:"reshaped_input_sizes",val:""},{name:"mask_threshold",val:" = 0.0"},{name:"binarize",val:" = True"},{name:"pad_size",val:" = None"}],parametersDescription:[{anchor:"transformers.SamImageProcessor.post_process_masks.masks",description:`<strong>masks</strong> (<code>torch.Tensor</code>) &#x2014;
Batched masks from the mask_decoder in (batch_size, num_channels, height, width) format.`,name:"masks"},{anchor:"transformers.SamImageProcessor.post_process_masks.original_sizes",description:`<strong>original_sizes</strong> (<code>torch.Tensor</code>) &#x2014;
The original size of the images before resizing for input to the model, in (height, width) format.`,name:"original_sizes"},{anchor:"transformers.SamImageProcessor.post_process_masks.reshaped_input_sizes",description:`<strong>reshaped_input_sizes</strong> (<code>torch.Tensor</code>) &#x2014;
The size of the image input to the model, in (height, width) format. Used to remove padding.`,name:"reshaped_input_sizes"},{anchor:"transformers.SamImageProcessor.post_process_masks.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The threshold to use for binarizing the masks.`,name:"mask_threshold"},{anchor:"transformers.SamImageProcessor.post_process_masks.binarize",description:`<strong>binarize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to binarize the masks.`,name:"binarize"},{anchor:"transformers.SamImageProcessor.post_process_masks.pad_size",description:`<strong>pad_size</strong> (<code>int</code>, <em>optional</em>, defaults to <code>self.pad_size</code>) &#x2014;
The target size the images were padded to before being passed to the model. If None, the target size is
assumed to be the processor&#x2019;s <code>pad_size</code>.`,name:"pad_size"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/sam/image_processing_sam.py#L363",returnDescription:`
<p>Batched masks in batch_size, num_channels, height, width) format, where (height, width)
is given by original_size.</p>
`,returnType:`
<p>(<code>torch.Tensor</code>)</p>
`}}),io=new C({props:{name:"preprocess",anchor:"transformers.SamImageProcessor.preprocess",parameters:[{name:"images",val:": typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]]"},{name:"do_resize",val:": typing.Optional[bool] = None"},{name:"size",val:": typing.Union[typing.Dict[str, int], NoneType] = None"},{name:"resample",val:": typing.Optional[ForwardRef('PILImageResampling')] = None"},{name:"do_rescale",val:": typing.Optional[bool] = None"},{name:"rescale_factor",val:": typing.Union[int, float, NoneType] = None"},{name:"do_normalize",val:": typing.Optional[bool] = None"},{name:"image_mean",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"do_pad",val:": typing.Optional[bool] = None"},{name:"pad_size",val:": typing.Union[typing.Dict[str, int], NoneType] = None"},{name:"do_convert_rgb",val:": bool = None"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"data_format",val:": ChannelDimension = <ChannelDimension.FIRST: 'channels_first'>"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamImageProcessor.preprocess.images",description:`<strong>images</strong> (<code>ImageInput</code>) &#x2014;
Image to preprocess.`,name:"images"},{anchor:"transformers.SamImageProcessor.preprocess.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_resize</code>) &#x2014;
Whether to resize the image.`,name:"do_resize"},{anchor:"transformers.SamImageProcessor.preprocess.size",description:`<strong>size</strong> (<code>Dict[str, int]</code>, <em>optional</em>, defaults to <code>self.size</code>) &#x2014;
Controls the size of the image after <code>resize</code>. The longest edge of the image is resized to
<code>size[&quot;longest_edge&quot;]</code> whilst preserving the aspect ratio.`,name:"size"},{anchor:"transformers.SamImageProcessor.preprocess.resample",description:`<strong>resample</strong> (<code>PILImageResampling</code>, <em>optional</em>, defaults to <code>self.resample</code>) &#x2014;
<code>PILImageResampling</code> filter to use when resizing the image e.g. <code>PILImageResampling.BILINEAR</code>.`,name:"resample"},{anchor:"transformers.SamImageProcessor.preprocess.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_rescale</code>) &#x2014;
Whether to rescale the image pixel values by rescaling factor.`,name:"do_rescale"},{anchor:"transformers.SamImageProcessor.preprocess.rescale_factor",description:`<strong>rescale_factor</strong> (<code>int</code> or <code>float</code>, <em>optional</em>, defaults to <code>self.rescale_factor</code>) &#x2014;
Rescale factor to apply to the image pixel values.`,name:"rescale_factor"},{anchor:"transformers.SamImageProcessor.preprocess.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_normalize</code>) &#x2014;
Whether to normalize the image.`,name:"do_normalize"},{anchor:"transformers.SamImageProcessor.preprocess.image_mean",description:`<strong>image_mean</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>self.image_mean</code>) &#x2014;
Image mean to normalize the image by if <code>do_normalize</code> is set to <code>True</code>.`,name:"image_mean"},{anchor:"transformers.SamImageProcessor.preprocess.image_std",description:`<strong>image_std</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>self.image_std</code>) &#x2014;
Image standard deviation to normalize the image by if <code>do_normalize</code> is set to <code>True</code>.`,name:"image_std"},{anchor:"transformers.SamImageProcessor.preprocess.do_pad",description:`<strong>do_pad</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_pad</code>) &#x2014;
Whether to pad the image.`,name:"do_pad"},{anchor:"transformers.SamImageProcessor.preprocess.pad_size",description:`<strong>pad_size</strong> (<code>Dict[str, int]</code>, <em>optional</em>, defaults to <code>self.pad_size</code>) &#x2014;
Controls the size of the padding applied to the image. The image is padded to <code>pad_size[&quot;height&quot;]</code> and
<code>pad_size[&quot;width&quot;]</code> if <code>do_pad</code> is set to <code>True</code>.`,name:"pad_size"},{anchor:"transformers.SamImageProcessor.preprocess.do_convert_rgb",description:`<strong>do_convert_rgb</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_convert_rgb</code>) &#x2014;
Whether to convert the image to RGB.`,name:"do_convert_rgb"},{anchor:"transformers.SamImageProcessor.preprocess.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <code>TensorType</code>, <em>optional</em>) &#x2014;
The type of tensors to return. Can be one of:<ul>
<li>Unset: Return a list of <code>np.ndarray</code>.</li>
<li><code>TensorType.TENSORFLOW</code> or <code>&apos;tf&apos;</code>: Return a batch of type <code>tf.Tensor</code>.</li>
<li><code>TensorType.PYTORCH</code> or <code>&apos;pt&apos;</code>: Return a batch of type <code>torch.Tensor</code>.</li>
<li><code>TensorType.NUMPY</code> or <code>&apos;np&apos;</code>: Return a batch of type <code>np.ndarray</code>.</li>
<li><code>TensorType.JAX</code> or <code>&apos;jax&apos;</code>: Return a batch of type <code>jax.numpy.ndarray</code>.</li>
</ul>`,name:"return_tensors"},{anchor:"transformers.SamImageProcessor.preprocess.data_format",description:`<strong>data_format</strong> (<code>ChannelDimension</code> or <code>str</code>, <em>optional</em>, defaults to <code>ChannelDimension.FIRST</code>) &#x2014;
The channel dimension format for the output image. Can be one of:<ul>
<li><code>&quot;channels_first&quot;</code> or <code>ChannelDimension.FIRST</code>: image in (num_channels, height, width) format.</li>
<li><code>&quot;channels_last&quot;</code> or <code>ChannelDimension.LAST</code>: image in (height, width, num_channels) format.</li>
<li>Unset: Use the channel dimension format of the input image.</li>
</ul>`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/sam/image_processing_sam.py#L238"}}),mo=new C({props:{name:"rescale",anchor:"transformers.SamImageProcessor.rescale",parameters:[{name:"image",val:": ndarray"},{name:"scale",val:": typing.Union[int, float]"},{name:"data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension, NoneType] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamImageProcessor.rescale.image",description:`<strong>image</strong> (<code>np.ndarray</code>) &#x2014;
Image to rescale.`,name:"image"},{anchor:"transformers.SamImageProcessor.rescale.scale",description:`<strong>scale</strong> (<code>int</code> or <code>float</code>) &#x2014;
Scale to apply to the image.`,name:"scale"},{anchor:"transformers.SamImageProcessor.rescale.data_format",description:`<strong>data_format</strong> (<code>str</code> or <code>ChannelDimension</code>, <em>optional</em>) &#x2014;
The channel dimension format of the image. If not provided, it will be the same as the input image.`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/sam/image_processing_sam.py#L195"}}),co=new C({props:{name:"resize",anchor:"transformers.SamImageProcessor.resize",parameters:[{name:"image",val:": ndarray"},{name:"size",val:": typing.Dict[str, int]"},{name:"resample",val:": Resampling = <Resampling.BICUBIC: 3>"},{name:"data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension, NoneType] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamImageProcessor.resize.image",description:`<strong>image</strong> (<code>np.ndarray</code>) &#x2014;
Image to resize.`,name:"image"},{anchor:"transformers.SamImageProcessor.resize.size",description:`<strong>size</strong> (<code>Dict[str, int]</code>) &#x2014;
Dictionary in the format <code>{&quot;longest_edge&quot;: int}</code> specifying the size of the output image. The longest
edge of the image will be resized to the specified size, while the other edge will be resized to
maintain the aspect ratio.
resample &#x2014;
<code>PILImageResampling</code> filter to use when resizing the image e.g. <code>PILImageResampling.BILINEAR</code>.`,name:"size"},{anchor:"transformers.SamImageProcessor.resize.data_format",description:`<strong>data_format</strong> (<code>ChannelDimension</code> or <code>str</code>, <em>optional</em>) &#x2014;
The channel dimension format for the output image. If unset, the channel dimension format of the input
image is used. Can be one of:<ul>
<li><code>&quot;channels_first&quot;</code> or <code>ChannelDimension.FIRST</code>: image in (num_channels, height, width) format.</li>
<li><code>&quot;channels_last&quot;</code> or <code>ChannelDimension.LAST</code>: image in (height, width, num_channels) format.</li>
</ul>`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/sam/image_processing_sam.py#L160",returnDescription:`
<p>The resized image.</p>
`,returnType:`
<p><code>np.ndarray</code></p>
`}}),po=new ne({}),fo=new C({props:{name:"class transformers.SamModel",anchor:"transformers.SamModel",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.SamModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/sam#transformers.SamConfig">SamConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/sam/modeling_sam.py#L1159"}}),_o=new C({props:{name:"forward",anchor:"transformers.SamModel.forward",parameters:[{name:"pixel_values",val:": typing.Optional[torch.FloatTensor] = None"},{name:"input_points",val:": typing.Optional[torch.FloatTensor] = None"},{name:"input_labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"input_boxes",val:": typing.Optional[torch.FloatTensor] = None"},{name:"input_masks",val:": typing.Optional[torch.LongTensor] = None"},{name:"image_embeddings",val:": typing.Optional[torch.FloatTensor] = None"},{name:"multimask_output",val:": bool = True"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:" = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamModel.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/sam#transformers.SamProcessor">SamProcessor</a>. See <code>SamProcessor.__call__()</code> for
details.`,name:"pixel_values"},{anchor:"transformers.SamModel.forward.input_points",description:`<strong>input_points</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_points, 2)</code>) &#x2014;
Input 2D spatial points, this is used by the prompt encoder to encode the prompt. Generally yields to much
better results. The points can be obtained by passing a list of list of list to the processor that will
create corresponding <code>torch</code> tensors of dimension 4. The first dimension is the image batch size, the
second dimension is the point batch size (i.e. how many segmentation masks do we want the model to predict
per input point), the third dimension is the number of points per segmentation mask (it is possible to pass
multiple points for a single mask), and the last dimension is the x (vertical) and y (horizontal)
coordinates of the point. If a different number of points is passed either for each image, or for each
mask, the processor will create &#x201C;PAD&#x201D; points that will correspond to the (0, 0) coordinate, and the
computation of the embedding will be skipped for these points using the labels.`,name:"input_points"},{anchor:"transformers.SamModel.forward.input_labels",description:`<strong>input_labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, point_batch_size, num_points)</code>) &#x2014;
Input labels for the points, this is used by the prompt encoder to encode the prompt. According to the
official implementation, there are 3 types of labels</p>
<ul>
<li><code>1</code>: the point is a point that contains the object of interest</li>
<li><code>0</code>: the point is a point that does not contain the object of interest</li>
<li><code>-1</code>: the point corresponds to the background</li>
</ul>
<p>We added the label:</p>
<ul>
<li><code>-10</code>: the point is a padding point, thus should be ignored by the prompt encoder</li>
</ul>
<p>The padding labels should be automatically done by the processor.`,name:"input_labels"},{anchor:"transformers.SamModel.forward.input_boxes",description:`<strong>input_boxes</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_boxes, 4)</code>) &#x2014;
Input boxes for the points, this is used by the prompt encoder to encode the prompt. Generally yields to
much better generated masks. The boxes can be obtained by passing a list of list of list to the processor,
that will generate a <code>torch</code> tensor, with each dimension corresponding respectively to the image batch
size, the number of boxes per image and the coordinates of the top left and botton right point of the box.
In the order (<code>x1</code>, <code>y1</code>, <code>x2</code>, <code>y2</code>):</p>
<ul>
<li><code>x1</code>: the x coordinate of the top left point of the input box</li>
<li><code>y1</code>: the y coordinate of the top left point of the input box</li>
<li><code>x2</code>: the x coordinate of the bottom right point of the input box</li>
<li><code>y2</code>: the y coordinate of the bottom right point of the input box</li>
</ul>`,name:"input_boxes"},{anchor:"transformers.SamModel.forward.input_masks",description:`<strong>input_masks</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, image_size, image_size)</code>) &#x2014;
SAM model also accepts segmentation masks as input. The mask will be embedded by the prompt encoder to
generate a corresponding embedding, that will be fed later on to the mask decoder. These masks needs to be
manually fed by the user, and they need to be of shape (<code>batch_size</code>, <code>image_size</code>, <code>image_size</code>).`,name:"input_masks"},{anchor:"transformers.SamModel.forward.image_embeddings",description:`<strong>image_embeddings</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, output_channels, window_size, window_size)</code>) &#x2014;
Image embeddings, this is used by the mask decder to generate masks and iou scores. For more memory
efficient computation, users can first retrieve the image embeddings using the <code>get_image_embeddings</code>
method, and then feed them to the <code>forward</code> method instead of feeding the <code>pixel_values</code>.`,name:"image_embeddings"},{anchor:"transformers.SamModel.forward.multimask_output",description:`<strong>multimask_output</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
In the original implementation and paper, the model always outputs 3 masks per image (or per point / per
bounding box if relevant). However, it is possible to just output a single mask, that corresponds to the
&#x201C;best&#x201D; mask, by specifying <code>multimask_output=False</code>.`,name:"multimask_output"},{anchor:"transformers.SamModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.SamModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.SamModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/sam/modeling_sam.py#L1252"}}),$e=new fm({props:{$$slots:{default:[um]},$$scope:{ctx:So}}}),{c(){y=a("meta"),I=d(),w=a("h1"),$=a("a"),x=a("span"),h(f.$$.fragment),z=d(),re=a("span"),La=s("SAM"),Vt=d(),W=a("h2"),se=a("a"),rt=a("span"),h(Ce.$$.fragment),qa=d(),st=a("span"),Ra=s("Overview"),Ut=d(),ie=a("p"),Va=s("SAM (Segment Anything Model) was proposed in "),xe=a("a"),Ua=s("Segment Anything"),Oa=s(" by Alexander Kirillov, Eric Mintun, Nikhila Ravi, Hanzi Mao, Chloe Rolland, Laura Gustafson, Tete Xiao, Spencer Whitehead, Alex Berg, Wan-Yen Lo, Piotr Dollar, Ross Girshick."),Ot=d(),wo=a("p"),Wa=s("The model can be used to predict segmentation masks of any object of interest given an input image."),Wt=d(),$o=a("p"),zo=a("img"),Ft=d(),ko=a("p"),Fa=s("The abstract from the paper is the following:"),Bt=d(),Po=a("p"),Ee=a("em"),Ba=s("We introduce the Segment Anything (SA) project: a new task, model, and dataset for image segmentation. Using our efficient model in a data collection loop, we built the largest segmentation dataset to date (by far), with over 1 billion masks on 11M licensed and privacy respecting images. The model is designed and trained to be promptable, so it can transfer zero-shot to new image distributions and tasks. We evaluate its capabilities on numerous tasks and find that its zero-shot performance is impressive \u2014 often competitive with or even superior to prior fully supervised results. We are releasing the Segment Anything Model (SAM) and corresponding dataset (SA-1B) of 1B masks and 11M images at \\href{"),Te=a("a"),Ha=s("https://segment-anything.com}{https://segment-anything.com}"),Ga=s(" to foster research into foundation models for computer vision."),Ht=d(),Co=a("p"),Ya=s("Tips:"),Gt=d(),E=a("ul"),it=a("li"),Xa=s("The model predicts binary masks that states the presence or not of the object of interest given an image."),Za=d(),mt=a("li"),Ja=s("The model predicts much better results if input 2D points and/or input bounding boxes are provided"),Ka=d(),dt=a("li"),Qa=s("You can prompt multiple points for the same image, and predict a single mask."),en=d(),ct=a("li"),on=s("Fine-tuning the model is not supported yet"),tn=d(),Ie=a("li"),an=s("According to the paper, textual input should be also supported. However, at this time of writing this seems to be not supported according to "),Me=a("a"),nn=s("the official repository"),rn=s("."),Yt=d(),M=a("p"),sn=s("This model was contributed by "),De=a("a"),mn=s("ybelkada"),dn=s(" and "),Ae=a("a"),cn=s("ArthurZ"),ln=s(`.
The original code can be found `),Ne=a("a"),pn=s("here"),fn=s("."),Xt=d(),xo=a("p"),hn=s("Below is an example on how to run mask generation given an image and a 2D point:"),Zt=d(),h(je.$$.fragment),Jt=d(),Eo=a("p"),gn=s("Resources:"),Kt=d(),To=a("ul"),Io=a("li"),Le=a("a"),un=s("Demo notebook"),_n=s(" for using the model"),Qt=d(),F=a("h2"),me=a("a"),lt=a("span"),h(qe.$$.fragment),vn=d(),pt=a("span"),bn=s("SamConfig"),ea=d(),P=a("div"),h(Re.$$.fragment),yn=d(),q=a("p"),Mo=a("a"),Sn=s("SamConfig"),wn=s(" is the configuration class to store the configuration of a "),Do=a("a"),$n=s("SamModel"),zn=s(`. It is used to instantiate a
SAM model according to the specified arguments, defining the vision model, prompt-encoder model and mask decoder
configs. Instantiating a configuration with the defaults will yield a similar configuration to that of the
SAM-ViT-H `),Ve=a("a"),kn=s("facebook/sam-vit-huge"),Pn=s(" architecture."),Cn=d(),B=a("p"),xn=s("Configuration objects inherit from "),Ao=a("a"),En=s("PretrainedConfig"),Tn=s(` and can be used to control the model outputs. Read the
documentation from `),No=a("a"),In=s("PretrainedConfig"),Mn=s(" for more information."),Dn=d(),h(de.$$.fragment),An=d(),ce=a("div"),h(Ue.$$.fragment),Nn=d(),Oe=a("p"),jn=s("Serializes this instance to a Python dictionary. Override the default "),jo=a("a"),Ln=s("to_dict()"),qn=s("."),oa=d(),H=a("h2"),le=a("a"),ft=a("span"),h(We.$$.fragment),Rn=d(),ht=a("span"),Vn=s("SamVisionConfig"),ta=d(),D=a("div"),h(Fe.$$.fragment),Un=d(),G=a("p"),On=s("This is the configuration class to store the configuration of a "),gt=a("code"),Wn=s("SamVisionModel"),Fn=s(`. It is used to instantiate a SAM
vision encoder according to the specified arguments, defining the model architecture. Instantiating a configuration
defaults will yield a similar configuration to that of the SAM ViT-h
`),Be=a("a"),Bn=s("facebook/sam-vit-huge"),Hn=s(" architecture."),Gn=d(),Y=a("p"),Yn=s("Configuration objects inherit from "),Lo=a("a"),Xn=s("PretrainedConfig"),Zn=s(` and can be used to control the model outputs. Read the
documentation from `),qo=a("a"),Jn=s("PretrainedConfig"),Kn=s(" for more information."),aa=d(),X=a("h2"),pe=a("a"),ut=a("span"),h(He.$$.fragment),Qn=d(),_t=a("span"),er=s("SamMaskDecoderConfig"),na=d(),A=a("div"),h(Ge.$$.fragment),or=d(),Z=a("p"),tr=s("This is the configuration class to store the configuration of a "),vt=a("code"),ar=s("SamMaskDecoder"),nr=s(`. It is used to instantiate a SAM
mask decoder to the specified arguments, defining the model architecture. Instantiating a configuration defaults
will yield a similar configuration to that of the SAM-vit-h
`),Ye=a("a"),rr=s("facebook/sam-vit-huge"),sr=s(" architecture."),ir=d(),J=a("p"),mr=s("Configuration objects inherit from "),Ro=a("a"),dr=s("PretrainedConfig"),cr=s(` and can be used to control the model outputs. Read the
documentation from `),Vo=a("a"),lr=s("PretrainedConfig"),pr=s(" for more information."),ra=d(),K=a("h2"),fe=a("a"),bt=a("span"),h(Xe.$$.fragment),fr=d(),yt=a("span"),hr=s("SamPromptEncoderConfig"),sa=d(),N=a("div"),h(Ze.$$.fragment),gr=d(),j=a("p"),ur=s("This is the configuration class to store the configuration of a "),St=a("code"),_r=s("SamPromptEncoder"),vr=s(". The "),wt=a("code"),br=s("SamPromptEncoder"),yr=s(`
module is used to encode the input 2D points and bounding boxes. Instantiating a configuration defaults will yield
a similar configuration to that of the SAM-vit-h
`),Je=a("a"),Sr=s("facebook/sam-vit-huge"),wr=s(" architecture."),$r=d(),Q=a("p"),zr=s("Configuration objects inherit from "),Uo=a("a"),kr=s("PretrainedConfig"),Pr=s(` and can be used to control the model outputs. Read the
documentation from `),Oo=a("a"),Cr=s("PretrainedConfig"),xr=s(" for more information."),ia=d(),ee=a("h2"),he=a("a"),$t=a("span"),h(Ke.$$.fragment),Er=d(),zt=a("span"),Tr=s("SamProcessor"),ma=d(),L=a("div"),h(Qe.$$.fragment),Ir=d(),kt=a("p"),Mr=s(`Constructs a SAM processor which wraps a SAM image processor and an 2D points & Bounding boxes processor into a
single processor.`),Dr=d(),R=a("p"),Wo=a("a"),Ar=s("SamProcessor"),Nr=s(" offers all the functionalities of "),Fo=a("a"),jr=s("SamImageProcessor"),Lr=s(`. See the docstring of
`),eo=a("a"),Pt=a("strong"),qr=s("call"),Rr=s("()"),Vr=s(" for more information."),da=d(),oe=a("h2"),ge=a("a"),Ct=a("span"),h(oo.$$.fragment),Ur=d(),xt=a("span"),Or=s("SamImageProcessor"),ca=d(),S=a("div"),h(to.$$.fragment),Wr=d(),Et=a("p"),Fr=s("Constructs a SAM image processor."),Br=d(),ue=a("div"),h(ao.$$.fragment),Hr=d(),Tt=a("p"),Gr=s("Normalize an image. image = (image - image_mean) / image_std."),Yr=d(),_e=a("div"),h(no.$$.fragment),Xr=d(),ro=a("p"),Zr=s("Pad an image to "),It=a("code"),Jr=s('(pad_size["height"], pad_size["width"])'),Kr=s(" with zeros to the right and bottom."),Qr=d(),ve=a("div"),h(so.$$.fragment),es=d(),Mt=a("p"),os=s("Remove padding and upscale masks to the original image size."),ts=d(),be=a("div"),h(io.$$.fragment),as=d(),Dt=a("p"),ns=s("Preprocess an image or batch of images."),rs=d(),ye=a("div"),h(mo.$$.fragment),ss=d(),At=a("p"),is=s("Rescale an image by a scale factor. image = image * scale."),ms=d(),Se=a("div"),h(co.$$.fragment),ds=d(),lo=a("p"),cs=s("Resize an image to "),Nt=a("code"),ls=s('(size["height"], size["width"])'),ps=s("."),la=d(),te=a("h2"),we=a("a"),jt=a("span"),h(po.$$.fragment),fs=d(),Lt=a("span"),hs=s("SamModel"),pa=d(),T=a("div"),h(fo.$$.fragment),gs=d(),ho=a("p"),us=s(`Segment Anything Model (SAM) for generating segmentation masks, given an input image and  optional 2D location and bounding boxes.
This model inherits from `),Bo=a("a"),_s=s("PreTrainedModel"),vs=s(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),bs=d(),go=a("p"),ys=s("This model is also a PyTorch "),uo=a("a"),Ss=s("torch.nn.Module"),ws=s(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),$s=d(),V=a("div"),h(_o.$$.fragment),zs=d(),ae=a("p"),ks=s("The "),Ho=a("a"),Ps=s("SamModel"),Cs=s(" forward method, overrides the "),qt=a("code"),xs=s("__call__"),Es=s(" special method."),Ts=d(),h($e.$$.fragment),this.h()},l(o){const l=dm('[data-svelte="svelte-1phssyn"]',document.head);y=n(l,"META",{name:!0,content:!0}),l.forEach(t),I=c(o),w=n(o,"H1",{class:!0});var vo=r(w);$=n(vo,"A",{id:!0,class:!0,href:!0});var Rt=r($);x=n(Rt,"SPAN",{});var As=r(x);g(f.$$.fragment,As),As.forEach(t),Rt.forEach(t),z=c(vo),re=n(vo,"SPAN",{});var Ns=r(re);La=i(Ns,"SAM"),Ns.forEach(t),vo.forEach(t),Vt=c(o),W=n(o,"H2",{class:!0});var ha=r(W);se=n(ha,"A",{id:!0,class:!0,href:!0});var js=r(se);rt=n(js,"SPAN",{});var Ls=r(rt);g(Ce.$$.fragment,Ls),Ls.forEach(t),js.forEach(t),qa=c(ha),st=n(ha,"SPAN",{});var qs=r(st);Ra=i(qs,"Overview"),qs.forEach(t),ha.forEach(t),Ut=c(o),ie=n(o,"P",{});var ga=r(ie);Va=i(ga,"SAM (Segment Anything Model) was proposed in "),xe=n(ga,"A",{href:!0,rel:!0});var Rs=r(xe);Ua=i(Rs,"Segment Anything"),Rs.forEach(t),Oa=i(ga," by Alexander Kirillov, Eric Mintun, Nikhila Ravi, Hanzi Mao, Chloe Rolland, Laura Gustafson, Tete Xiao, Spencer Whitehead, Alex Berg, Wan-Yen Lo, Piotr Dollar, Ross Girshick."),ga.forEach(t),Ot=c(o),wo=n(o,"P",{});var Vs=r(wo);Wa=i(Vs,"The model can be used to predict segmentation masks of any object of interest given an input image."),Vs.forEach(t),Wt=c(o),$o=n(o,"P",{});var Us=r($o);zo=n(Us,"IMG",{src:!0,alt:!0}),Us.forEach(t),Ft=c(o),ko=n(o,"P",{});var Os=r(ko);Fa=i(Os,"The abstract from the paper is the following:"),Os.forEach(t),Bt=c(o),Po=n(o,"P",{});var Ws=r(Po);Ee=n(Ws,"EM",{});var ua=r(Ee);Ba=i(ua,"We introduce the Segment Anything (SA) project: a new task, model, and dataset for image segmentation. Using our efficient model in a data collection loop, we built the largest segmentation dataset to date (by far), with over 1 billion masks on 11M licensed and privacy respecting images. The model is designed and trained to be promptable, so it can transfer zero-shot to new image distributions and tasks. We evaluate its capabilities on numerous tasks and find that its zero-shot performance is impressive \u2014 often competitive with or even superior to prior fully supervised results. We are releasing the Segment Anything Model (SAM) and corresponding dataset (SA-1B) of 1B masks and 11M images at \\href{"),Te=n(ua,"A",{href:!0,rel:!0});var Fs=r(Te);Ha=i(Fs,"https://segment-anything.com}{https://segment-anything.com}"),Fs.forEach(t),Ga=i(ua," to foster research into foundation models for computer vision."),ua.forEach(t),Ws.forEach(t),Ht=c(o),Co=n(o,"P",{});var Bs=r(Co);Ya=i(Bs,"Tips:"),Bs.forEach(t),Gt=c(o),E=n(o,"UL",{});var U=r(E);it=n(U,"LI",{});var Hs=r(it);Xa=i(Hs,"The model predicts binary masks that states the presence or not of the object of interest given an image."),Hs.forEach(t),Za=c(U),mt=n(U,"LI",{});var Gs=r(mt);Ja=i(Gs,"The model predicts much better results if input 2D points and/or input bounding boxes are provided"),Gs.forEach(t),Ka=c(U),dt=n(U,"LI",{});var Ys=r(dt);Qa=i(Ys,"You can prompt multiple points for the same image, and predict a single mask."),Ys.forEach(t),en=c(U),ct=n(U,"LI",{});var Xs=r(ct);on=i(Xs,"Fine-tuning the model is not supported yet"),Xs.forEach(t),tn=c(U),Ie=n(U,"LI",{});var _a=r(Ie);an=i(_a,"According to the paper, textual input should be also supported. However, at this time of writing this seems to be not supported according to "),Me=n(_a,"A",{href:!0,rel:!0});var Zs=r(Me);nn=i(Zs,"the official repository"),Zs.forEach(t),rn=i(_a,"."),_a.forEach(t),U.forEach(t),Yt=c(o),M=n(o,"P",{});var ze=r(M);sn=i(ze,"This model was contributed by "),De=n(ze,"A",{href:!0,rel:!0});var Js=r(De);mn=i(Js,"ybelkada"),Js.forEach(t),dn=i(ze," and "),Ae=n(ze,"A",{href:!0,rel:!0});var Ks=r(Ae);cn=i(Ks,"ArthurZ"),Ks.forEach(t),ln=i(ze,`.
The original code can be found `),Ne=n(ze,"A",{href:!0,rel:!0});var Qs=r(Ne);pn=i(Qs,"here"),Qs.forEach(t),fn=i(ze,"."),ze.forEach(t),Xt=c(o),xo=n(o,"P",{});var ei=r(xo);hn=i(ei,"Below is an example on how to run mask generation given an image and a 2D point:"),ei.forEach(t),Zt=c(o),g(je.$$.fragment,o),Jt=c(o),Eo=n(o,"P",{});var oi=r(Eo);gn=i(oi,"Resources:"),oi.forEach(t),Kt=c(o),To=n(o,"UL",{});var ti=r(To);Io=n(ti,"LI",{});var Is=r(Io);Le=n(Is,"A",{href:!0,rel:!0});var ai=r(Le);un=i(ai,"Demo notebook"),ai.forEach(t),_n=i(Is," for using the model"),Is.forEach(t),ti.forEach(t),Qt=c(o),F=n(o,"H2",{class:!0});var va=r(F);me=n(va,"A",{id:!0,class:!0,href:!0});var ni=r(me);lt=n(ni,"SPAN",{});var ri=r(lt);g(qe.$$.fragment,ri),ri.forEach(t),ni.forEach(t),vn=c(va),pt=n(va,"SPAN",{});var si=r(pt);bn=i(si,"SamConfig"),si.forEach(t),va.forEach(t),ea=c(o),P=n(o,"DIV",{class:!0});var O=r(P);g(Re.$$.fragment,O),yn=c(O),q=n(O,"P",{});var bo=r(q);Mo=n(bo,"A",{href:!0});var ii=r(Mo);Sn=i(ii,"SamConfig"),ii.forEach(t),wn=i(bo," is the configuration class to store the configuration of a "),Do=n(bo,"A",{href:!0});var mi=r(Do);$n=i(mi,"SamModel"),mi.forEach(t),zn=i(bo,`. It is used to instantiate a
SAM model according to the specified arguments, defining the vision model, prompt-encoder model and mask decoder
configs. Instantiating a configuration with the defaults will yield a similar configuration to that of the
SAM-ViT-H `),Ve=n(bo,"A",{href:!0,rel:!0});var di=r(Ve);kn=i(di,"facebook/sam-vit-huge"),di.forEach(t),Pn=i(bo," architecture."),bo.forEach(t),Cn=c(O),B=n(O,"P",{});var Go=r(B);xn=i(Go,"Configuration objects inherit from "),Ao=n(Go,"A",{href:!0});var ci=r(Ao);En=i(ci,"PretrainedConfig"),ci.forEach(t),Tn=i(Go,` and can be used to control the model outputs. Read the
documentation from `),No=n(Go,"A",{href:!0});var li=r(No);In=i(li,"PretrainedConfig"),li.forEach(t),Mn=i(Go," for more information."),Go.forEach(t),Dn=c(O),g(de.$$.fragment,O),An=c(O),ce=n(O,"DIV",{class:!0});var ba=r(ce);g(Ue.$$.fragment,ba),Nn=c(ba),Oe=n(ba,"P",{});var ya=r(Oe);jn=i(ya,"Serializes this instance to a Python dictionary. Override the default "),jo=n(ya,"A",{href:!0});var pi=r(jo);Ln=i(pi,"to_dict()"),pi.forEach(t),qn=i(ya,"."),ya.forEach(t),ba.forEach(t),O.forEach(t),oa=c(o),H=n(o,"H2",{class:!0});var Sa=r(H);le=n(Sa,"A",{id:!0,class:!0,href:!0});var fi=r(le);ft=n(fi,"SPAN",{});var hi=r(ft);g(We.$$.fragment,hi),hi.forEach(t),fi.forEach(t),Rn=c(Sa),ht=n(Sa,"SPAN",{});var gi=r(ht);Vn=i(gi,"SamVisionConfig"),gi.forEach(t),Sa.forEach(t),ta=c(o),D=n(o,"DIV",{class:!0});var Yo=r(D);g(Fe.$$.fragment,Yo),Un=c(Yo),G=n(Yo,"P",{});var Xo=r(G);On=i(Xo,"This is the configuration class to store the configuration of a "),gt=n(Xo,"CODE",{});var ui=r(gt);Wn=i(ui,"SamVisionModel"),ui.forEach(t),Fn=i(Xo,`. It is used to instantiate a SAM
vision encoder according to the specified arguments, defining the model architecture. Instantiating a configuration
defaults will yield a similar configuration to that of the SAM ViT-h
`),Be=n(Xo,"A",{href:!0,rel:!0});var _i=r(Be);Bn=i(_i,"facebook/sam-vit-huge"),_i.forEach(t),Hn=i(Xo," architecture."),Xo.forEach(t),Gn=c(Yo),Y=n(Yo,"P",{});var Zo=r(Y);Yn=i(Zo,"Configuration objects inherit from "),Lo=n(Zo,"A",{href:!0});var vi=r(Lo);Xn=i(vi,"PretrainedConfig"),vi.forEach(t),Zn=i(Zo,` and can be used to control the model outputs. Read the
documentation from `),qo=n(Zo,"A",{href:!0});var bi=r(qo);Jn=i(bi,"PretrainedConfig"),bi.forEach(t),Kn=i(Zo," for more information."),Zo.forEach(t),Yo.forEach(t),aa=c(o),X=n(o,"H2",{class:!0});var wa=r(X);pe=n(wa,"A",{id:!0,class:!0,href:!0});var yi=r(pe);ut=n(yi,"SPAN",{});var Si=r(ut);g(He.$$.fragment,Si),Si.forEach(t),yi.forEach(t),Qn=c(wa),_t=n(wa,"SPAN",{});var wi=r(_t);er=i(wi,"SamMaskDecoderConfig"),wi.forEach(t),wa.forEach(t),na=c(o),A=n(o,"DIV",{class:!0});var Jo=r(A);g(Ge.$$.fragment,Jo),or=c(Jo),Z=n(Jo,"P",{});var Ko=r(Z);tr=i(Ko,"This is the configuration class to store the configuration of a "),vt=n(Ko,"CODE",{});var $i=r(vt);ar=i($i,"SamMaskDecoder"),$i.forEach(t),nr=i(Ko,`. It is used to instantiate a SAM
mask decoder to the specified arguments, defining the model architecture. Instantiating a configuration defaults
will yield a similar configuration to that of the SAM-vit-h
`),Ye=n(Ko,"A",{href:!0,rel:!0});var zi=r(Ye);rr=i(zi,"facebook/sam-vit-huge"),zi.forEach(t),sr=i(Ko," architecture."),Ko.forEach(t),ir=c(Jo),J=n(Jo,"P",{});var Qo=r(J);mr=i(Qo,"Configuration objects inherit from "),Ro=n(Qo,"A",{href:!0});var ki=r(Ro);dr=i(ki,"PretrainedConfig"),ki.forEach(t),cr=i(Qo,` and can be used to control the model outputs. Read the
documentation from `),Vo=n(Qo,"A",{href:!0});var Pi=r(Vo);lr=i(Pi,"PretrainedConfig"),Pi.forEach(t),pr=i(Qo," for more information."),Qo.forEach(t),Jo.forEach(t),ra=c(o),K=n(o,"H2",{class:!0});var $a=r(K);fe=n($a,"A",{id:!0,class:!0,href:!0});var Ci=r(fe);bt=n(Ci,"SPAN",{});var xi=r(bt);g(Xe.$$.fragment,xi),xi.forEach(t),Ci.forEach(t),fr=c($a),yt=n($a,"SPAN",{});var Ei=r(yt);hr=i(Ei,"SamPromptEncoderConfig"),Ei.forEach(t),$a.forEach(t),sa=c(o),N=n(o,"DIV",{class:!0});var et=r(N);g(Ze.$$.fragment,et),gr=c(et),j=n(et,"P",{});var ke=r(j);ur=i(ke,"This is the configuration class to store the configuration of a "),St=n(ke,"CODE",{});var Ti=r(St);_r=i(Ti,"SamPromptEncoder"),Ti.forEach(t),vr=i(ke,". The "),wt=n(ke,"CODE",{});var Ii=r(wt);br=i(Ii,"SamPromptEncoder"),Ii.forEach(t),yr=i(ke,`
module is used to encode the input 2D points and bounding boxes. Instantiating a configuration defaults will yield
a similar configuration to that of the SAM-vit-h
`),Je=n(ke,"A",{href:!0,rel:!0});var Mi=r(Je);Sr=i(Mi,"facebook/sam-vit-huge"),Mi.forEach(t),wr=i(ke," architecture."),ke.forEach(t),$r=c(et),Q=n(et,"P",{});var ot=r(Q);zr=i(ot,"Configuration objects inherit from "),Uo=n(ot,"A",{href:!0});var Di=r(Uo);kr=i(Di,"PretrainedConfig"),Di.forEach(t),Pr=i(ot,` and can be used to control the model outputs. Read the
documentation from `),Oo=n(ot,"A",{href:!0});var Ai=r(Oo);Cr=i(Ai,"PretrainedConfig"),Ai.forEach(t),xr=i(ot," for more information."),ot.forEach(t),et.forEach(t),ia=c(o),ee=n(o,"H2",{class:!0});var za=r(ee);he=n(za,"A",{id:!0,class:!0,href:!0});var Ni=r(he);$t=n(Ni,"SPAN",{});var ji=r($t);g(Ke.$$.fragment,ji),ji.forEach(t),Ni.forEach(t),Er=c(za),zt=n(za,"SPAN",{});var Li=r(zt);Tr=i(Li,"SamProcessor"),Li.forEach(t),za.forEach(t),ma=c(o),L=n(o,"DIV",{class:!0});var tt=r(L);g(Qe.$$.fragment,tt),Ir=c(tt),kt=n(tt,"P",{});var qi=r(kt);Mr=i(qi,`Constructs a SAM processor which wraps a SAM image processor and an 2D points & Bounding boxes processor into a
single processor.`),qi.forEach(t),Dr=c(tt),R=n(tt,"P",{});var yo=r(R);Wo=n(yo,"A",{href:!0});var Ri=r(Wo);Ar=i(Ri,"SamProcessor"),Ri.forEach(t),Nr=i(yo," offers all the functionalities of "),Fo=n(yo,"A",{href:!0});var Vi=r(Fo);jr=i(Vi,"SamImageProcessor"),Vi.forEach(t),Lr=i(yo,`. See the docstring of
`),eo=n(yo,"A",{href:!0});var Ms=r(eo);Pt=n(Ms,"STRONG",{});var Ui=r(Pt);qr=i(Ui,"call"),Ui.forEach(t),Rr=i(Ms,"()"),Ms.forEach(t),Vr=i(yo," for more information."),yo.forEach(t),tt.forEach(t),da=c(o),oe=n(o,"H2",{class:!0});var ka=r(oe);ge=n(ka,"A",{id:!0,class:!0,href:!0});var Oi=r(ge);Ct=n(Oi,"SPAN",{});var Wi=r(Ct);g(oo.$$.fragment,Wi),Wi.forEach(t),Oi.forEach(t),Ur=c(ka),xt=n(ka,"SPAN",{});var Fi=r(xt);Or=i(Fi,"SamImageProcessor"),Fi.forEach(t),ka.forEach(t),ca=c(o),S=n(o,"DIV",{class:!0});var k=r(S);g(to.$$.fragment,k),Wr=c(k),Et=n(k,"P",{});var Bi=r(Et);Fr=i(Bi,"Constructs a SAM image processor."),Bi.forEach(t),Br=c(k),ue=n(k,"DIV",{class:!0});var Pa=r(ue);g(ao.$$.fragment,Pa),Hr=c(Pa),Tt=n(Pa,"P",{});var Hi=r(Tt);Gr=i(Hi,"Normalize an image. image = (image - image_mean) / image_std."),Hi.forEach(t),Pa.forEach(t),Yr=c(k),_e=n(k,"DIV",{class:!0});var Ca=r(_e);g(no.$$.fragment,Ca),Xr=c(Ca),ro=n(Ca,"P",{});var xa=r(ro);Zr=i(xa,"Pad an image to "),It=n(xa,"CODE",{});var Gi=r(It);Jr=i(Gi,'(pad_size["height"], pad_size["width"])'),Gi.forEach(t),Kr=i(xa," with zeros to the right and bottom."),xa.forEach(t),Ca.forEach(t),Qr=c(k),ve=n(k,"DIV",{class:!0});var Ea=r(ve);g(so.$$.fragment,Ea),es=c(Ea),Mt=n(Ea,"P",{});var Yi=r(Mt);os=i(Yi,"Remove padding and upscale masks to the original image size."),Yi.forEach(t),Ea.forEach(t),ts=c(k),be=n(k,"DIV",{class:!0});var Ta=r(be);g(io.$$.fragment,Ta),as=c(Ta),Dt=n(Ta,"P",{});var Xi=r(Dt);ns=i(Xi,"Preprocess an image or batch of images."),Xi.forEach(t),Ta.forEach(t),rs=c(k),ye=n(k,"DIV",{class:!0});var Ia=r(ye);g(mo.$$.fragment,Ia),ss=c(Ia),At=n(Ia,"P",{});var Zi=r(At);is=i(Zi,"Rescale an image by a scale factor. image = image * scale."),Zi.forEach(t),Ia.forEach(t),ms=c(k),Se=n(k,"DIV",{class:!0});var Ma=r(Se);g(co.$$.fragment,Ma),ds=c(Ma),lo=n(Ma,"P",{});var Da=r(lo);cs=i(Da,"Resize an image to "),Nt=n(Da,"CODE",{});var Ji=r(Nt);ls=i(Ji,'(size["height"], size["width"])'),Ji.forEach(t),ps=i(Da,"."),Da.forEach(t),Ma.forEach(t),k.forEach(t),la=c(o),te=n(o,"H2",{class:!0});var Aa=r(te);we=n(Aa,"A",{id:!0,class:!0,href:!0});var Ki=r(we);jt=n(Ki,"SPAN",{});var Qi=r(jt);g(po.$$.fragment,Qi),Qi.forEach(t),Ki.forEach(t),fs=c(Aa),Lt=n(Aa,"SPAN",{});var em=r(Lt);hs=i(em,"SamModel"),em.forEach(t),Aa.forEach(t),pa=c(o),T=n(o,"DIV",{class:!0});var Pe=r(T);g(fo.$$.fragment,Pe),gs=c(Pe),ho=n(Pe,"P",{});var Na=r(ho);us=i(Na,`Segment Anything Model (SAM) for generating segmentation masks, given an input image and  optional 2D location and bounding boxes.
This model inherits from `),Bo=n(Na,"A",{href:!0});var om=r(Bo);_s=i(om,"PreTrainedModel"),om.forEach(t),vs=i(Na,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Na.forEach(t),bs=c(Pe),go=n(Pe,"P",{});var ja=r(go);ys=i(ja,"This model is also a PyTorch "),uo=n(ja,"A",{href:!0,rel:!0});var tm=r(uo);Ss=i(tm,"torch.nn.Module"),tm.forEach(t),ws=i(ja,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),ja.forEach(t),$s=c(Pe),V=n(Pe,"DIV",{class:!0});var at=r(V);g(_o.$$.fragment,at),zs=c(at),ae=n(at,"P",{});var nt=r(ae);ks=i(nt,"The "),Ho=n(nt,"A",{href:!0});var am=r(Ho);Ps=i(am,"SamModel"),am.forEach(t),Cs=i(nt," forward method, overrides the "),qt=n(nt,"CODE",{});var nm=r(qt);xs=i(nm,"__call__"),nm.forEach(t),Es=i(nt," special method."),nt.forEach(t),Ts=c(at),g($e.$$.fragment,at),at.forEach(t),Pe.forEach(t),this.h()},h(){m(y,"name","hf:doc:metadata"),m(y,"content",JSON.stringify(vm)),m($,"id","sam"),m($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m($,"href","#sam"),m(w,"class","relative group"),m(se,"id","overview"),m(se,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(se,"href","#overview"),m(W,"class","relative group"),m(xe,"href","https://arxiv.org/pdf/2304.02643v1.pdf"),m(xe,"rel","nofollow"),cm(zo.src,Ds="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/transformers/model_doc/sam-output.png")||m(zo,"src",Ds),m(zo,"alt","example image"),m(Te,"href","https://segment-anything.com}{https://segment-anything.com}"),m(Te,"rel","nofollow"),m(Me,"href","https://github.com/facebookresearch/segment-anything/issues/4#issuecomment-1497626844"),m(Me,"rel","nofollow"),m(De,"href","https://huggingface.co/ybelkada"),m(De,"rel","nofollow"),m(Ae,"href","https://huggingface.co/ArthurZ"),m(Ae,"rel","nofollow"),m(Ne,"href","https://github.com/facebookresearch/segment-anything"),m(Ne,"rel","nofollow"),m(Le,"href","https://github.com/huggingface/notebooks/blob/main/examples/segment_anything.ipynb"),m(Le,"rel","nofollow"),m(me,"id","transformers.SamConfig"),m(me,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(me,"href","#transformers.SamConfig"),m(F,"class","relative group"),m(Mo,"href","/docs/transformers/main/en/model_doc/sam#transformers.SamConfig"),m(Do,"href","/docs/transformers/main/en/model_doc/sam#transformers.SamModel"),m(Ve,"href","https://huggingface.co/facebook/sam-vit-huge"),m(Ve,"rel","nofollow"),m(Ao,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),m(No,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),m(jo,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig.to_dict"),m(ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(le,"id","transformers.SamVisionConfig"),m(le,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(le,"href","#transformers.SamVisionConfig"),m(H,"class","relative group"),m(Be,"href","https://huggingface.co/facebook/sam-vit-huge"),m(Be,"rel","nofollow"),m(Lo,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),m(qo,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),m(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(pe,"id","transformers.SamMaskDecoderConfig"),m(pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(pe,"href","#transformers.SamMaskDecoderConfig"),m(X,"class","relative group"),m(Ye,"href","https://huggingface.co/facebook/sam-vit-huge"),m(Ye,"rel","nofollow"),m(Ro,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),m(Vo,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),m(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(fe,"id","transformers.SamPromptEncoderConfig"),m(fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(fe,"href","#transformers.SamPromptEncoderConfig"),m(K,"class","relative group"),m(Je,"href","https://huggingface.co/facebook/sam-vit-huge"),m(Je,"rel","nofollow"),m(Uo,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),m(Oo,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),m(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(he,"id","transformers.SamProcessor"),m(he,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(he,"href","#transformers.SamProcessor"),m(ee,"class","relative group"),m(Wo,"href","/docs/transformers/main/en/model_doc/sam#transformers.SamProcessor"),m(Fo,"href","/docs/transformers/main/en/model_doc/sam#transformers.SamImageProcessor"),m(eo,"href","/docs/transformers/main/en/model_doc/mobilevit#transformers.MobileViTFeatureExtractor.__call__"),m(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(ge,"id","transformers.SamImageProcessor"),m(ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(ge,"href","#transformers.SamImageProcessor"),m(oe,"class","relative group"),m(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(we,"id","transformers.SamModel"),m(we,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(we,"href","#transformers.SamModel"),m(te,"class","relative group"),m(Bo,"href","/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),m(uo,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),m(uo,"rel","nofollow"),m(Ho,"href","/docs/transformers/main/en/model_doc/sam#transformers.SamModel"),m(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,l){e(document.head,y),p(o,I,l),p(o,w,l),e(w,$),e($,x),u(f,x,null),e(w,z),e(w,re),e(re,La),p(o,Vt,l),p(o,W,l),e(W,se),e(se,rt),u(Ce,rt,null),e(W,qa),e(W,st),e(st,Ra),p(o,Ut,l),p(o,ie,l),e(ie,Va),e(ie,xe),e(xe,Ua),e(ie,Oa),p(o,Ot,l),p(o,wo,l),e(wo,Wa),p(o,Wt,l),p(o,$o,l),e($o,zo),p(o,Ft,l),p(o,ko,l),e(ko,Fa),p(o,Bt,l),p(o,Po,l),e(Po,Ee),e(Ee,Ba),e(Ee,Te),e(Te,Ha),e(Ee,Ga),p(o,Ht,l),p(o,Co,l),e(Co,Ya),p(o,Gt,l),p(o,E,l),e(E,it),e(it,Xa),e(E,Za),e(E,mt),e(mt,Ja),e(E,Ka),e(E,dt),e(dt,Qa),e(E,en),e(E,ct),e(ct,on),e(E,tn),e(E,Ie),e(Ie,an),e(Ie,Me),e(Me,nn),e(Ie,rn),p(o,Yt,l),p(o,M,l),e(M,sn),e(M,De),e(De,mn),e(M,dn),e(M,Ae),e(Ae,cn),e(M,ln),e(M,Ne),e(Ne,pn),e(M,fn),p(o,Xt,l),p(o,xo,l),e(xo,hn),p(o,Zt,l),u(je,o,l),p(o,Jt,l),p(o,Eo,l),e(Eo,gn),p(o,Kt,l),p(o,To,l),e(To,Io),e(Io,Le),e(Le,un),e(Io,_n),p(o,Qt,l),p(o,F,l),e(F,me),e(me,lt),u(qe,lt,null),e(F,vn),e(F,pt),e(pt,bn),p(o,ea,l),p(o,P,l),u(Re,P,null),e(P,yn),e(P,q),e(q,Mo),e(Mo,Sn),e(q,wn),e(q,Do),e(Do,$n),e(q,zn),e(q,Ve),e(Ve,kn),e(q,Pn),e(P,Cn),e(P,B),e(B,xn),e(B,Ao),e(Ao,En),e(B,Tn),e(B,No),e(No,In),e(B,Mn),e(P,Dn),u(de,P,null),e(P,An),e(P,ce),u(Ue,ce,null),e(ce,Nn),e(ce,Oe),e(Oe,jn),e(Oe,jo),e(jo,Ln),e(Oe,qn),p(o,oa,l),p(o,H,l),e(H,le),e(le,ft),u(We,ft,null),e(H,Rn),e(H,ht),e(ht,Vn),p(o,ta,l),p(o,D,l),u(Fe,D,null),e(D,Un),e(D,G),e(G,On),e(G,gt),e(gt,Wn),e(G,Fn),e(G,Be),e(Be,Bn),e(G,Hn),e(D,Gn),e(D,Y),e(Y,Yn),e(Y,Lo),e(Lo,Xn),e(Y,Zn),e(Y,qo),e(qo,Jn),e(Y,Kn),p(o,aa,l),p(o,X,l),e(X,pe),e(pe,ut),u(He,ut,null),e(X,Qn),e(X,_t),e(_t,er),p(o,na,l),p(o,A,l),u(Ge,A,null),e(A,or),e(A,Z),e(Z,tr),e(Z,vt),e(vt,ar),e(Z,nr),e(Z,Ye),e(Ye,rr),e(Z,sr),e(A,ir),e(A,J),e(J,mr),e(J,Ro),e(Ro,dr),e(J,cr),e(J,Vo),e(Vo,lr),e(J,pr),p(o,ra,l),p(o,K,l),e(K,fe),e(fe,bt),u(Xe,bt,null),e(K,fr),e(K,yt),e(yt,hr),p(o,sa,l),p(o,N,l),u(Ze,N,null),e(N,gr),e(N,j),e(j,ur),e(j,St),e(St,_r),e(j,vr),e(j,wt),e(wt,br),e(j,yr),e(j,Je),e(Je,Sr),e(j,wr),e(N,$r),e(N,Q),e(Q,zr),e(Q,Uo),e(Uo,kr),e(Q,Pr),e(Q,Oo),e(Oo,Cr),e(Q,xr),p(o,ia,l),p(o,ee,l),e(ee,he),e(he,$t),u(Ke,$t,null),e(ee,Er),e(ee,zt),e(zt,Tr),p(o,ma,l),p(o,L,l),u(Qe,L,null),e(L,Ir),e(L,kt),e(kt,Mr),e(L,Dr),e(L,R),e(R,Wo),e(Wo,Ar),e(R,Nr),e(R,Fo),e(Fo,jr),e(R,Lr),e(R,eo),e(eo,Pt),e(Pt,qr),e(eo,Rr),e(R,Vr),p(o,da,l),p(o,oe,l),e(oe,ge),e(ge,Ct),u(oo,Ct,null),e(oe,Ur),e(oe,xt),e(xt,Or),p(o,ca,l),p(o,S,l),u(to,S,null),e(S,Wr),e(S,Et),e(Et,Fr),e(S,Br),e(S,ue),u(ao,ue,null),e(ue,Hr),e(ue,Tt),e(Tt,Gr),e(S,Yr),e(S,_e),u(no,_e,null),e(_e,Xr),e(_e,ro),e(ro,Zr),e(ro,It),e(It,Jr),e(ro,Kr),e(S,Qr),e(S,ve),u(so,ve,null),e(ve,es),e(ve,Mt),e(Mt,os),e(S,ts),e(S,be),u(io,be,null),e(be,as),e(be,Dt),e(Dt,ns),e(S,rs),e(S,ye),u(mo,ye,null),e(ye,ss),e(ye,At),e(At,is),e(S,ms),e(S,Se),u(co,Se,null),e(Se,ds),e(Se,lo),e(lo,cs),e(lo,Nt),e(Nt,ls),e(lo,ps),p(o,la,l),p(o,te,l),e(te,we),e(we,jt),u(po,jt,null),e(te,fs),e(te,Lt),e(Lt,hs),p(o,pa,l),p(o,T,l),u(fo,T,null),e(T,gs),e(T,ho),e(ho,us),e(ho,Bo),e(Bo,_s),e(ho,vs),e(T,bs),e(T,go),e(go,ys),e(go,uo),e(uo,Ss),e(go,ws),e(T,$s),e(T,V),u(_o,V,null),e(V,zs),e(V,ae),e(ae,ks),e(ae,Ho),e(Ho,Ps),e(ae,Cs),e(ae,qt),e(qt,xs),e(ae,Es),e(V,Ts),u($e,V,null),fa=!0},p(o,[l]){const vo={};l&2&&(vo.$$scope={dirty:l,ctx:o}),de.$set(vo);const Rt={};l&2&&(Rt.$$scope={dirty:l,ctx:o}),$e.$set(Rt)},i(o){fa||(_(f.$$.fragment,o),_(Ce.$$.fragment,o),_(je.$$.fragment,o),_(qe.$$.fragment,o),_(Re.$$.fragment,o),_(de.$$.fragment,o),_(Ue.$$.fragment,o),_(We.$$.fragment,o),_(Fe.$$.fragment,o),_(He.$$.fragment,o),_(Ge.$$.fragment,o),_(Xe.$$.fragment,o),_(Ze.$$.fragment,o),_(Ke.$$.fragment,o),_(Qe.$$.fragment,o),_(oo.$$.fragment,o),_(to.$$.fragment,o),_(ao.$$.fragment,o),_(no.$$.fragment,o),_(so.$$.fragment,o),_(io.$$.fragment,o),_(mo.$$.fragment,o),_(co.$$.fragment,o),_(po.$$.fragment,o),_(fo.$$.fragment,o),_(_o.$$.fragment,o),_($e.$$.fragment,o),fa=!0)},o(o){v(f.$$.fragment,o),v(Ce.$$.fragment,o),v(je.$$.fragment,o),v(qe.$$.fragment,o),v(Re.$$.fragment,o),v(de.$$.fragment,o),v(Ue.$$.fragment,o),v(We.$$.fragment,o),v(Fe.$$.fragment,o),v(He.$$.fragment,o),v(Ge.$$.fragment,o),v(Xe.$$.fragment,o),v(Ze.$$.fragment,o),v(Ke.$$.fragment,o),v(Qe.$$.fragment,o),v(oo.$$.fragment,o),v(to.$$.fragment,o),v(ao.$$.fragment,o),v(no.$$.fragment,o),v(so.$$.fragment,o),v(io.$$.fragment,o),v(mo.$$.fragment,o),v(co.$$.fragment,o),v(po.$$.fragment,o),v(fo.$$.fragment,o),v(_o.$$.fragment,o),v($e.$$.fragment,o),fa=!1},d(o){t(y),o&&t(I),o&&t(w),b(f),o&&t(Vt),o&&t(W),b(Ce),o&&t(Ut),o&&t(ie),o&&t(Ot),o&&t(wo),o&&t(Wt),o&&t($o),o&&t(Ft),o&&t(ko),o&&t(Bt),o&&t(Po),o&&t(Ht),o&&t(Co),o&&t(Gt),o&&t(E),o&&t(Yt),o&&t(M),o&&t(Xt),o&&t(xo),o&&t(Zt),b(je,o),o&&t(Jt),o&&t(Eo),o&&t(Kt),o&&t(To),o&&t(Qt),o&&t(F),b(qe),o&&t(ea),o&&t(P),b(Re),b(de),b(Ue),o&&t(oa),o&&t(H),b(We),o&&t(ta),o&&t(D),b(Fe),o&&t(aa),o&&t(X),b(He),o&&t(na),o&&t(A),b(Ge),o&&t(ra),o&&t(K),b(Xe),o&&t(sa),o&&t(N),b(Ze),o&&t(ia),o&&t(ee),b(Ke),o&&t(ma),o&&t(L),b(Qe),o&&t(da),o&&t(oe),b(oo),o&&t(ca),o&&t(S),b(to),b(ao),b(no),b(so),b(io),b(mo),b(co),o&&t(la),o&&t(te),b(po),o&&t(pa),o&&t(T),b(fo),b(_o),b($e)}}}const vm={local:"sam",sections:[{local:"overview",title:"Overview"},{local:"transformers.SamConfig",title:"SamConfig"},{local:"transformers.SamVisionConfig",title:"SamVisionConfig"},{local:"transformers.SamMaskDecoderConfig",title:"SamMaskDecoderConfig"},{local:"transformers.SamPromptEncoderConfig",title:"SamPromptEncoderConfig"},{local:"transformers.SamProcessor",title:"SamProcessor"},{local:"transformers.SamImageProcessor",title:"SamImageProcessor"},{local:"transformers.SamModel",title:"SamModel"}],title:"SAM"};function bm(So){return lm(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Pm extends sm{constructor(y){super();im(this,y,bm,_m,mm,{})}}export{Pm as default,vm as metadata};
